#! /usr/bin/python
# -*- coding: utf-8 -*-
'''
Created on 25.09.2012

@author: tolmi
'''
import urlparse, urllib, os, mutagen, sys, re, codecs

class MSSFile(object):
    '''
    classdocs
        Пока ничего не придумал. А в связи с глобальной ленью скорее всего никогда и не напишу.
    '''
    error = ''
    error_cnt = 0
    error_cnt_imm = 0
    sConfigFileName = u''
    URI = None
    _filename = None
    _filesize = 0L
    _bitrate = 0
    _duration = 0
    _disk_no = None
    UFID = ''
    _log_queue = None
    stdout_utf = None
    stderr_utf = None
    def __init__(self, ConfigFileName='', URI='', log_queue=None):
        '''
        Constructor
        '''
        try:
            self.stdout_utf = codecs.getwriter('utf8')(sys.stdout)
            self.stderr_utf = codecs.getwriter('utf8')(sys.stderr)
            self.sConfigFileName = ConfigFileName
            self._log_queue = log_queue 
            self.URI = URI
            parse_result = urlparse.urlparse(URI)
            if parse_result.scheme == 'file': #pylint: disable=E1101
                encfile = parse_result.path #pylint: disable=E1101
                u8dec = codecs.getdecoder('utf-8')
                encfile = encfile.encode('ascii')
                mfilename = urllib.unquote(encfile)
                bfilename, icount = u8dec(mfilename)
                self.debug(repr((bfilename, icount))) 
                self._filename = bfilename
            else:
                self._filename = None
        except Exception as e:
            self.debug('MSS __init__  Error: %s' % repr(e))
            self.error += '\n in __init__ :' + repr(e)
            self.error_cnt += 1
    def debug(self, message):
        if not  self._log_queue is None: 
            self._log_queue.put(message)
    def FileName(self):
        return self._filename
    def FileSize(self):
        try:
            psstat = os.stat(self._filename)
            self._filesize = psstat.st_size
            return self._filesize
        except Exception as e:
            self.error += '\n in FileSize :' + repr(e)
            self.error_cnt += 1
            return None
    def ProcessFile(self, in_file_name=None):
        if not in_file_name is None: self._filename = in_file_name 
        try:
            tags = mutagen.File(self._filename, options=None, easy=False)
            if tags != None:
                rtype = repr(tags.mime).lower()
                if ('mp3' in rtype):
                    self._bitrate = int(tags.info.bitrate / 1000)
                    self._duration = int(tags.info.length)
                    self._disk_no = self.getID3tag(tags, 'TPOS', ttype='i')
                    a = tags.get('UFID:Amarok 2 AFTv1 - amarok.kde.org')
                    if a != None:
                        self.UFID = a.data
                    else:
                        self.UFID = ''
                elif ('flac' in rtype):
                    self._duration = int(tags.info.length)
                    self._bitrate = int(self._filesize / self._duration * 8 / 1000)
                    self._disk_no = self.getFLACtag(tags, 'discnumber', ttype='i')
                    a = tags.get('AMAROK 2 AFTV1 - AMAROK.KDE.ORG')
                    if a != None:
                        self.UFID = a[0]
                    else:
                        self.UFID = ''
                elif ('audio/vorbis' in rtype):
                    self._duration = int(tags.info.length)
                    self._bitrate = int(tags.info.bitrate / 1000)
                    self._disk_no = self.getVORBIStag(tags=tags, tname='discnumber', ttype='i')
                    self.UFID = self.getVORBIStag(tags=tags, tname='amarok 2 aftv1 - amarok.kde.org', ttype='s')
                else:
                    self.error += '\n Unknown file type in ProcessFile :' + repr(rtype)
                    self.error_cnt += 1
                    self._duration = -1
                    self._bitrate = -1
                    self._disk_no = -1
                    self.UFID = '#ERROR#'
        except Exception as e:
            self.error += '\n in ProcessFile :' + repr(e)
            self.error_cnt += 1
            return None
    def BitRate(self):
        return self._bitrate
    def Disk_Number(self):
        return self._disk_no
    def to_int(self, in_str):
        try:
            if isinstance(in_str, (int, long)):
                return in_str
            elif type(in_str) is float:
                return long(in_str)
            elif isinstance(in_str, (str, unicode)):
                arrn = re.findall('\b*\d+', in_str)
                return long(arrn[0])
            else:
                print >> self.stderr_utf, "Unknown type %s" % repr(type(in_str))
                return -1L
        except Exception as e:
            print >> self.stderr_utf, "Error %s in to_to_int() , in_str(%s)=%s" % (repr(e), repr(type(in_str)), in_str)
            return -1L
    def getID3tag(self, tags, tname, ttype='s'):
        zzzz = None
        try:
            zzzz = tags.get(tname)
            if zzzz != None:
                zzz = zzzz.data
                if ttype == 's':
                    return zzz
                elif ttype == 'i':
                    try:
                        return self.to_int(zzz)
                    except:
                        return -1
            else:
                if ttype == 's':
                    return ''
                elif ttype == 'i':
                    return -1
        except:
            pass
        try:
            zz = zzzz.text
            zzz = zz[0].text
            if ttype == 's':
                return zzz
            elif ttype == 'i':
                try:
                    return self.to_int(zzz)
                except:
                    return -1
        except :
            pass
        try:
            zzz = zz[0]
            if ttype == 's':
                return zzz
            elif ttype == 'i':
                try:
                    return self.to_int(zzz)
                except:
                    return -1
        except :
            return ''
    def getFLACtag(self, tags, tname, ttype='s'):
        try:
            zzzz = tags.get(tname)
            if zzzz != None:
                if ttype == 's':
                    return zzzz[0]
                elif ttype == 'i':
                    try:
                        return self.to_int(zzzz[0])
                    except:
                        return -1
            else:
                if ttype == 's':
                    return ''
                elif ttype == 'i':
                    return -1
        except:
            if ttype == 's':
                return ''
            elif ttype == 'i':
                return -1
    def getVORBIStag(self, tags, tname, ttype='s'):
        try:
            zzzz = tags.get(tname)
            if zzzz != None:
                if ttype == 's':
                    return zzzz[0]
                elif ttype == 'i':
                    try:
                        return self.to_int(zzzz[0])
                    except:
                        return -1
            else:
                if ttype == 's':
                    return ''
                elif ttype == 'i':
                    return -1
        except:
            if ttype == 's':
                return ''
            elif ttype == 'i':
                return -1
